package cn.ibizlab.assetmanagement.core.location.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.location.domain.EAMLocation;
import cn.ibizlab.assetmanagement.core.location.filter.EAMLocationSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMLocation] 服务对象接口
 */
public interface IEAMLocationService extends IService<EAMLocation>{

    boolean create(EAMLocation et) ;
    void createBatch(List<EAMLocation> list) ;
    boolean update(EAMLocation et) ;
    void updateBatch(List<EAMLocation> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMLocation get(String key) ;
    EAMLocation getDraft(EAMLocation et) ;
    boolean checkKey(EAMLocation et) ;
    boolean save(EAMLocation et) ;
    void saveBatch(List<EAMLocation> list) ;
    Page<EAMLocation> searchDefault(EAMLocationSearchContext context) ;
    List<EAMLocation> selectByEamlocationstateid(String eamlocationstateid) ;
    void removeByEamlocationstateid(String eamlocationstateid) ;
    List<EAMLocation> selectByEamlocationtypeid(String eamlocationtypeid) ;
    void removeByEamlocationtypeid(String eamlocationtypeid) ;
    List<EAMLocation> selectByPeamlocationid(String eamlocationid) ;
    void removeByPeamlocationid(String eamlocationid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMLocation> getEamlocationByIds(List<String> ids) ;
    List<EAMLocation> getEamlocationByEntities(List<EAMLocation> entities) ;
}


